This is an extension and not part of the main GoJS library. Note that the API for this class may change at any time. If you intend to use an extension in production, you should copy the code to your own source directory. Extensions can be found in the GoJS kit under the `extensions` or `extensionsTS` folders. See the Extensions intro page for more information.

### Hierarchy

- Tool
  - LinkReshapingTool
    - SnapLinkReshapingTool

The SnapLinkReshapingTool class lets the user snap link reshaping handles to the nearest grid point. If avoidsNodes is true and the link is orthogonal, it also avoids reshaping the link so that any adjacent segments cross over any avoidable nodes.

If you want to experiment with this extension, try the Snap Link Reshaping sample.

## Index

### Properties

- avoidsNodes
- gridCellSize
- gridOrigin
- isGridSnapEnabled

### Methods

- computeReshape
- doActivate

## Properties

### avoidsNodes : boolean

- Gets or sets whether a reshape handle's position should only be dragged where the adjacent segments do not cross over any nodes. This affects the behavior of computeReshape.

  The default value is true.

### gridCellSize : Size

- Gets or sets the Size of each grid cell to which link points will be snapped.

  The default value is NaNxNaN, which means use the Diagram.grid's Panel.gridCellSize.

### gridOrigin : Point

- Gets or sets the Point origin for the grid to which link points will be snapped.

  The default value is NaN,NaN, which means use the Diagram.grid's Panel.gridOrigin.

### isGridSnapEnabled : boolean

- Gets or sets whether a reshape handle's position should be snapped to a grid point. This affects the behavior of computeReshape.

  The default value is true.

## Methods

### Override computeReshape

- computeReshape(p: Point): Point

- Pretend while dragging a reshape handle the mouse point is at the nearest grid point, if isGridSnapEnabled is true. This uses gridCellSize and gridOrigin, unless those are not real values, in which case this uses the Diagram.grid's Panel.gridCellSize and Panel.gridOrigin.

  If avoidsNodes is true and the adorned Link is Link.isOrthogonal, this method also avoids returning a Point that causes the adjacent segments, both before and after the current handle's index, to cross over any Nodes that are Node.avoidable.

  #### Parameters

  - ##### p: Point

  #### Returns Point

### Override doActivate

- doActivate(): void

- This override records information about the original point of the handle being dragged, if the adornedLink is Orthogonal and if avoidsNodes is true.

  #### Returns void

Copyright © 1998-2020 by Northwoods Software Corporation.